/****************************************************************************/
/*                 Universal Battery Check for Canon Cam's     	    	    */
/****************************************************************************/
/* Created:       05.08.2006 [BORLAND C 3.1]                                */
/* Last modified: 20.05.2007 [BORLAND C 3.1]	                            */
/* Copyright (C) 2006 by AlexG (special thanks to RayeR and Johan Borg)     */
/* Compiler: Borland C++ 3.1, disable Word Alignment, set 80186 code gen.   */
/****************************************************************************/
#define CAMERA_S70
#include "psiolib.c"                   // PowerShot I/O library 2.0+
#include <stdio.h>
#include <dos.h>

#define u8 unsigned char
#define s8 signed char
#define u16 unsigned int
#define s16 signed int
#define u32 unsigned long

DWord key;

float voltage;
float  charge;

float x;

//#define DEBUG

#ifdef DEBUG
u8 xs[10];
#endif

void alg_nimh4(u16 adc_data)
{
 voltage=adc_data/80.0;
 charge =(100*(voltage-4.1)/(5.2-4.1));
 if (charge>100) charge=100;
 if (charge<0) charge=0;
}

void alg_liion1p(u16 adc_data)
{
float c[6]={6.9486E2,1.0831E1,-5.0445E-1,1.0751E-2,-1.0263E-4,3.6514E-7};
float chg=50,stp=25;

#ifdef DEBUG
//adc_data=0x2F5;
#endif

 voltage=adc_data/104.5983;

 x=adc_data;
 for(u8 j=0;j<10;j++)
 {
  if ((c[0]
      +c[1]*chg
      +c[2]*chg*chg
      +c[3]*chg*chg*chg
      +c[4]*chg*chg*chg*chg
      +c[5]*chg*chg*chg*chg*chg
      +c[6]*chg*chg*chg*chg*chg*chg)>x)
   {
    chg=chg-stp;
   }
  else
   {
    chg=chg+stp;
   }
   stp=stp/2;
#ifdef DEBUG
  xs[j]=chg;
#endif
 }
 charge=chg;

 if (charge>100) charge=100;
 if (charge<0) charge=0;
}

void alg_liion_BP_511(u16 adc_data)
{
 alg_liion1p(adc_data);
 charge*=1.06496;

 if (charge>100) charge=100;
 if (charge<0) charge=0;
}

void alg_liion_ixus(u16 adc_data)
{
alg_liion1p(adc_data);

voltage=voltage/2;

}


void alg_nimh2p(u16 adc_data)
{
float c[6]={5.204E2,4.089,-1.588E-1,3.477E-3,-3.767E-5,1.574E-7};
float chg=50,stp=25;

 voltage=adc_data/229.2375;

 x=adc_data;
 for(u8 j=0;j<10;j++)
 {
  if ((c[0]
      +c[1]*chg
      +c[2]*chg*chg
      +c[3]*chg*chg*chg
      +c[4]*chg*chg*chg*chg
      +c[5]*chg*chg*chg*chg*chg
      +c[6]*chg*chg*chg*chg*chg*chg)>x)
   {
    chg=chg-stp;
   }
  else
   {
    chg=chg+stp;
   }
   stp=stp/2;
 #ifdef DEBUG
  xs[j]=chg;
 #endif
 }
 charge=chg;

}

int main(void)
{
u16   adc_data;
u16 pid;
u8 ns,ts;

u16 pids[]={0x309D,0x30B3,0x3085,0x306E,0x30B1,0x30B2,0x3077,0x306D,0x30C2,0x30C1,0x30B7,0x30BB,0x30B9,0x309A,0x30B5,0x3073,0x3074,0x3072,0x3075,0x3058,0xFFFF};
u8 pidsel=0;

float T;

  ps_init();
  ps_cls(0,0);
  ps_set_pal(ps_default_palette,0);

  do {
    key=ps_get_key_state();
    ps_gotoxy(0,0);
    ps_draw_frect(0,0,PS_SCREEN_XRES,PS_SCREEN_YRES,15,0);
    ps_printf(0,14,0,"*** Battery Check 0.4M by AlexG ****\n");
    ps_gotoxy(1,2);

    pid=ps_get_pid();
    ns=0;
    ts=0;

    if (pidsel>0) pid=pids[pidsel-1];

    switch(pid)
    {
     case 0x309D: ps_printf(0,4,0," Pro1 - supported,thx 2 svd\n");  //Pro1
		  adc_data=inport(0xF02E);
		  alg_liion_BP_511(adc_data); ts=2;
		  break;
     case 0x30B3: ps_printf(0,7,0," G6 - not tested\n");  //G6
		  adc_data=inport(0xF02E);
		  alg_liion1p(adc_data);
		  break;
     case 0x3085: ps_printf(0,7,0," G5 - not tested\n");  //G5
		  adc_data=inport(0xF02E);
		  alg_liion1p(adc_data);
		  break;
     case 0x306E:
     case 0x306F: ps_printf(0,7,0," G3 - not tested\n");  //G3
		  adc_data=inport(0xF02E);
		  alg_liion1p(adc_data);
		  break;
     case 0x30B1: ps_printf(0,4,0," S70 - supported\n");  //S70
		  adc_data=inport(0xF02C);                //T2
		  alg_liion1p(adc_data); ts=2;
		  break;
     case 0x30B2: ps_printf(0,7,0," S60 - not tested\n"); //S60
		  adc_data=inport(0xF02C);                //T2
		  alg_liion1p(adc_data); ts=2;
		  break;
     case 0x3077: ps_printf(0,7,0," S50 - not tested\n");  //S50
		  adc_data=inport(0xF02E);
		  alg_liion1p(adc_data);
		  break;
     case 0x306C:
     case 0x306D: ps_printf(0,7,0," S45 - not tested\n");  //S45
		  adc_data=inport(0xF02E);
		  alg_liion1p(adc_data);
		  break;
     case 0x30C2: ps_printf(0,4,0," A510 - supported,thx 2 tklim\n");  //A510  //0xF030,>0xF036<
		  adc_data=inport(0xF02A);                             //T1
		  alg_nimh2p(adc_data); ts=1;
		  break;
     case 0x30C1: ps_printf(0,4,0," A520 - supported,thx 2 ugk4088\n");//A520
		  adc_data=inport(0xF02A);                             //T1
		  alg_nimh2p(adc_data); ts=1;
		  break;
     case 0x30B7: ps_printf(0,4,0," A400 - supported,thx 2 axxx\n");  //A400
		  adc_data=inport(0xF02A);                            //T1
		  alg_nimh2p(adc_data); ts=1;
		  break;
     case 0x30BB: ps_printf(0,4,0," A95 - supported\n");  //A95
		  adc_data=inport(0xF02A);                //T1
		  alg_nimh4(adc_data); ts=2;
		  break;
     case 0x30B9: ps_printf(0,7,0," A85 - not tested\n"); //A85
		  adc_data=inport(0xF02A);                //T1
		  alg_nimh4(adc_data); ts=1;
		  break;
     case 0x309A: ps_printf(0,4,0," A80 - supported\n");  //A80
		  adc_data=inport(0xF02A);                //T1
		  alg_nimh4(adc_data); ts=1;
		  break;
     case 0x30B5: ps_printf(0,7,0," A75 - not tested\n");  //A75
		  adc_data=inport(0xF02A);                 //T1
		  alg_nimh4(adc_data); ts=1;
		  break;
     case 0x3073: ps_printf(0,4,0," A70 - supported\n");  //A70
		  adc_data=inport(0xF02A);                //T1
		  alg_nimh4(adc_data); ts=1;
		  break;
     case 0x3074: ps_printf(0,7,0," A60 - not tested\n");  //A60
		  adc_data=inport(0xF02A);                //T1
		  alg_nimh4(adc_data); ts=1;
		  break;
     case 0x3058: ps_printf(0,4,0," A40 - supported,thx 2 Duke\n");  //A40
		  adc_data=inport(0xF02A);                           //T1
		  alg_nimh4(adc_data); ts=1;
		  break;
     case 0x3072: ps_printf(0,7,0," Ixus II - not tested\n");  //Ixus II
		  adc_data=inport(0xF02A);                     //T1
		  alg_liion_ixus(adc_data); ts=1;
		  break;
     case 0x3075: ps_printf(0,7,0," Ixus 400 - not tested\n");  //Ixus 400
		  adc_data=inport(0xF02A);                      //T1
		  alg_liion_ixus(adc_data); ts=1;
		  break;
     default: ps_printf(0,2,0," unknown PID:%04X\n",pid);
	      ns=1;
    }

    T=51.1-0.081761*inport(0xF036);

    if (!ns)
    {
     ps_gotoxy(0,3);
    #ifdef DEBUG
     ps_gotoxy(0,2);
     ps_printf(0,14,0,"  ADC: %X\n",adc_data);
    #endif

     ps_printf(0,14,0,"  Battery voltage: %.2fV\n",voltage);
     if (charge<20) ps_printf(0,2,0,"  Battery charge: %3.1f%%\n", charge);
     else ps_printf(0,14,0,"  Battery charge: %3.1f%%\n", charge);

    #ifdef DEBUG
     ps_printf(0,14,0,"%u,%u,%u,%u,%u,%u,%u,%u,%u,%u\n",xs[0],xs[1],xs[2],xs[3],xs[4],xs[5],xs[6],xs[7],xs[8],xs[9]);
    #else
     ps_draw_frect(40,300-40,420,50,10,0);
     ps_draw_frect(460,315-40,10,20,10,0);
     ps_draw_frect(47,306-40,charge*4,38,2,0);
    #endif

    ps_gotoxy(2,7);
    if (ts==2) ps_printf(0,14,0,"Temperature: %+.1fC\n", T);
    else       ps_printf(0,14,0,"Temperature: 0x%3X (%+.1fC)\n", inport(0xF036),T);


    }
    else
    {
     u16 adc[8];
     for(u8 i=0;i<8;i++)
     adc[i]=inport(0xF028+i*2);

     ps_gotoxy(0,4);
     ps_printf(0,14,0," F028:%3X F02A:%3X F02C:%3X\n",adc[0],adc[1],adc[2]);
     ps_printf(0,14,0," F02E:%3X F030:%3X F032:%3X\n",adc[3],adc[4],adc[5]);
     ps_printf(0,14,0," F034:%3X F036:%3X\n",adc[6],adc[7]);
    }

    ps_gotoxy(1,8);
    ps_printf(1,14,0," Press any key to exit");

    if (key&PS_KEY_UP)
     {
       pidsel++;
       if (pidsel>21) pidsel=0;
       key=0;
     }
    if (key&PS_KEY_DOWN)
     {
       if (pidsel>0) pidsel--;
       else pidsel=21;
       key=0;
     }

  } while ((key&PS_KEY_ANY&~PS_KEY_VIEW)==0);

  return(0);
}
